package org.apache.bcel.generic;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import org.apache.bcel.classfile.Constant;
import org.apache.bcel.classfile.ConstantDouble;
import org.apache.bcel.classfile.ConstantLong;
import org.apache.bcel.generic.CPInstruction;
import org.apache.bcel.generic.ConstantPoolGen;
import org.apache.bcel.generic.PushInstruction;
import org.apache.bcel.generic.Type;
import org.apache.bcel.generic.Visitor;

public class LDC2_W extends CPInstruction implements PushInstruction {
  LDC2_W() {}
  
  public LDC2_W(int index) {
    super((short)20, index);
  }
  
  public void accept(Visitor v) {
    v.visitStackProducer(this);
    v.visitPushInstruction(this);
    v.visitTypedInstruction(this);
    v.visitCPInstruction(this);
    v.visitLDC2_W(this);
  }
  
  public Type getType(ConstantPoolGen cpg) {
    switch (cpg.getConstantPool().getConstant(getIndex()).getTag()) {
      case 5:
        return Type.LONG;
      case 6:
        return Type.DOUBLE;
    } 
    throw new IllegalArgumentException("Unknown constant type " + getOpcode());
  }
  
  public Number getValue(ConstantPoolGen cpg) {
    Constant c = cpg.getConstantPool().getConstant(getIndex());
    switch (c.getTag()) {
      case 5:
        return Long.valueOf(((ConstantLong)c).getBytes());
      case 6:
        return Double.valueOf(((ConstantDouble)c).getBytes());
    } 
    throw new IllegalArgumentException("Unknown or invalid constant type at " + getIndex());
  }
}
